// RobotControllerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RobotController.h"
#include "RobotControllerDlg.h"
#include "Windows.h"
#include "Winuser.h"
#include "Mmsystem.h" 

#pragma comment(lib,"Winmm")


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define cCmdLoop  15
#define cCmdTotal 10
//   
struct TCmdArray {
	BOOL Cmd[cCmdTotal];
};

HHOOK      hook_keyboard;
HHOOK      hook;
HANDLE	   hCOMPort;

TKeyArray gKeyArray;
TCmdArray gCmdArray;



// ""   
LRESULT CALLBACK HookProc(int iCode, WPARAM wParam, LPARAM lParam)
{
	MSG *msg = (MSG*)lParam;
	if (msg->message == WM_KEYDOWN) {
		if ((msg->wParam == 13) || (msg->wParam == 27)) msg->wParam = 1;
	}

	return CallNextHookEx(hook,iCode,wParam,lParam);
}

//	*******************************************************************
//	Add application icon to a tray window =============================
//	*******************************************************************
#define WM_NOTIFYICONMSG	(WM_USER + 2)

void AddTrayIcon(HWND hWnd,DWORD icon,DWORD Action)
{
	HICON hStatusIcon;
	LPCSTR pszIDStatusIcon;
	NOTIFYICONDATA tnd;

	pszIDStatusIcon = MAKEINTRESOURCE(icon);
	CWinApp* pApp= AfxGetApp();
	hStatusIcon = pApp->LoadIcon(MAKEINTRESOURCE(icon));
	tnd.cbSize = sizeof(NOTIFYICONDATA);
	tnd.hWnd = hWnd;
	tnd.uID = 1;
	tnd.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
	tnd.uCallbackMessage = WM_NOTIFYICONMSG;
	tnd.hIcon = hStatusIcon;
	lstrcpyn(tnd.szTip,"  ",sizeof(tnd.szTip));
	Shell_NotifyIcon(Action,&tnd );
}

//   
LRESULT CALLBACK LowLevelKeyboardProc(int iCode, WPARAM wParam, LPARAM lParam)
{
	if (iCode == HC_ACTION) {
		KBDLLHOOKSTRUCT *khs = (KBDLLHOOKSTRUCT*)lParam;

		if(wParam == WM_KEYDOWN || wParam == WM_KEYUP) {
			BOOL  KeyState = (wParam == WM_KEYDOWN);
			DWORD  KeyCode = khs->vkCode;
			switch(KeyCode) {
				case VK_SPACE:  gKeyArray.Key[7] = KeyState; break;
				case VK_DELETE: gKeyArray.Key[6] = KeyState; break;
				case VK_END:    gKeyArray.Key[5] = KeyState; break;
				case VK_NEXT:   gKeyArray.Key[4] = KeyState; break;
				case VK_RIGHT:  gKeyArray.Key[3] = KeyState; break;
				case VK_UP:     gKeyArray.Key[2] = KeyState; break;
				case VK_DOWN:   gKeyArray.Key[1] = KeyState; break;
				case VK_LEFT:   gKeyArray.Key[0] = KeyState; break;
			}
		}
	}

	return CallNextHookEx(hook_keyboard,iCode,wParam,lParam);
}

// 
inline void Pause(__int64 aTimeInterval, __int64 aTf, __int64 aBt) {
	LARGE_INTEGER Count;
	QueryPerformanceCounter(&Count);

	while((Count.QuadPart - aBt)/aTf < aTimeInterval) {
		Sleep(0);
		QueryPerformanceCounter(&Count);
	}
}

//    
void CmdTransmitting(void *arg)
{
	timeBeginPeriod(1);

	//   
	LARGE_INTEGER Count;
	LARGE_INTEGER Frequency;
	QueryPerformanceFrequency (&Frequency);
	__int64 Tf = Frequency.QuadPart/1000000;

	hCOMPort = CreateFile("\\\\.\\COM1",GENERIC_READ | GENERIC_WRITE, 0,
										NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	EscapeCommFunction(hCOMPort, CLRDTR);

	for(;;) {

		if(!memchr(&gCmdArray, TRUE, sizeof(TCmdArray))) { Sleep(1); continue; }

		for(int i=0; i<cCmdLoop; i++) {
			int j,CmdNum = 0;
			for(j=0; j<cCmdTotal; j++) {
				if(gCmdArray.Cmd[i]) { CmdNum++; }
			}

			#define csTime 670
			#define cbTime 1990

			for(j=0; j<cCmdTotal+1; j++) {
				QueryPerformanceCounter(&Count);

				BOOL s = (!j)?TRUE:gCmdArray.Cmd[j-1];

				EscapeCommFunction(hCOMPort, SETDTR);
				
				if(s && j < cCmdTotal) { Sleep(1); }
				
				if(j) { Pause((s)?cbTime:csTime, Tf, Count.QuadPart); }

				QueryPerformanceCounter(&Count);			
				EscapeCommFunction(hCOMPort, CLRDTR);

				if(!s && j < cCmdTotal) { Sleep(1); }

				Pause((s)?csTime:cbTime, Tf, Count.QuadPart);
			}
			QueryPerformanceCounter(&Count);
			EscapeCommFunction(hCOMPort, SETDTR);
			Sleep(4);

			if(memchr(&gCmdArray, TRUE, sizeof(TCmdArray))) { i=0; }

			Pause(4300, Tf, Count.QuadPart);
		}

		EscapeCommFunction(hCOMPort, CLRDTR);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRobotControllerDlg dialog

CRobotControllerDlg::CRobotControllerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRobotControllerDlg::IDD, pParent)
{
	mThr_CmdTransmitting = 0;	
	memset(&gKeyArray, 0, sizeof(TKeyArray));
	memset(&gCmdArray, 0, sizeof(TCmdArray));
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRobotControllerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRobotControllerDlg)
	DDX_Control(pDX, IDC_Indicator, m_Indicator);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRobotControllerDlg, CDialog)
	//{{AFX_MSG_MAP(CRobotControllerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRobotControllerDlg message handlers

BOOL CRobotControllerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//    
	bool AlreadyRunning;
    HANDLE hMutexOneInstance = ::CreateMutex( NULL, FALSE,
        _T("Robot_Controller_V1-073FA540-B11D-12D3-BC37-009097709574"));
    AlreadyRunning = (::GetLastError() == ERROR_ALREADY_EXISTS || 
                      ::GetLastError() == ERROR_ACCESS_DENIED);
	if (AlreadyRunning) {
		MessageBox("    .",
				   "  ",MB_ICONWARNING);
		exit(0);
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	mWinTrayState = 0;

	//   
	HOOKPROC hpHookProc;
	hpHookProc = (HOOKPROC)&HookProc;
	hook = SetWindowsHookEx(WH_GETMESSAGE,(HOOKPROC)hpHookProc,NULL,GetCurrentThreadId());

	
	hook_keyboard = SetWindowsHookEx(WH_KEYBOARD_LL,&LowLevelKeyboardProc,GetModuleHandle(NULL),0);

	//    
	AddTrayIcon(m_hWnd,IDR_MAINFRAME,NIM_ADD);

	//     
	mThr_CmdTransmitting = CreateThread(0,0,(LPTHREAD_START_ROUTINE)CmdTransmitting,0,0,0);
	SetThreadPriority(mThr_CmdTransmitting, THREAD_PRIORITY_TIME_CRITICAL);

	SetTimer(0,10,0);
	
	return TRUE;
}

void CRobotControllerDlg::OnClose() 
{
	if (MessageBox("       ?",
			           "    ",
					   MB_ICONWARNING|MB_YESNO|MB_DEFBUTTON2) == IDNO) { return; }

	AddTrayIcon(m_hWnd,IDR_MAINFRAME,NIM_DELETE);
	UnhookWindowsHookEx(hook);
	UnhookWindowsHookEx(hook_keyboard);
	CloseHandle(hCOMPort);

	if(mThr_CmdTransmitting) { TerminateThread(mThr_CmdTransmitting, 0); }

	CDialog::OnClose();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRobotControllerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if (mWinTrayState) ShowWindow(SW_HIDE);
		
		CDialog::OnPaint();
	}
}

HCURSOR CRobotControllerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//	==================================================================================
//	--------------     -------------------------------------
//	==================================================================================
LRESULT CRobotControllerDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (lParam == -2097118464) {
		//	  
		ShowWindow(SW_HIDE);
		mWinTrayState = 1;
	}
	if (message == WM_NOTIFYICONMSG && lParam == WM_LBUTTONDOWN) {
		//	  
		SetForegroundWindow();
		ShowWindow(SW_SHOWNORMAL);
		mWinTrayState = 0;
		return 0;
	}
	if (message == WM_NOTIFYICONMSG) return 0;

	
	return CDialog::DefWindowProc(message, wParam, lParam);
}

//  
void CRobotControllerDlg::OnTimer(UINT nIDEvent) 
{
	enum {
		kc_LEFT = 0,
		kc_DOWN,
		kc_UP,
		kc_RIGHT,
		kc_NEXT,
		kc_END,
		kc_DELETE,
		kc_SPACE
	};

	TCmdArray CmdArray;
	memset(&CmdArray, 0, sizeof(TCmdArray));

	for(int i=0; i<cKeyTotal; i++) {
		if(gKeyArray.Key[i]) {
			switch(i) {
				case kc_UP:
					CmdArray.Cmd[0] = TRUE;
					CmdArray.Cmd[2] = TRUE;

					if(gKeyArray.Key[kc_LEFT] || gKeyArray.Key[kc_RIGHT]) {

						CmdArray.Cmd[8] = TRUE;

						if(gKeyArray.Key[kc_LEFT]) {
							CmdArray.Cmd[0] = FALSE;
						} else {
							CmdArray.Cmd[2] = FALSE;
						}
					}
					break;

				case kc_DOWN:
					CmdArray.Cmd[1] = TRUE;
					CmdArray.Cmd[3] = TRUE;

					if(gKeyArray.Key[kc_LEFT] || gKeyArray.Key[kc_RIGHT]) {
						
						CmdArray.Cmd[8] = TRUE;

						if(gKeyArray.Key[kc_LEFT]) {
							CmdArray.Cmd[3] = FALSE;
						} else {
							CmdArray.Cmd[1] = FALSE;
						}
					}
					break;

				case kc_DELETE:
					CmdArray.Cmd[5] = TRUE;
					CmdArray.Cmd[8] = TRUE;
					break;

				case kc_NEXT:
					CmdArray.Cmd[4] = TRUE;
					CmdArray.Cmd[8] = TRUE;
					break;

				case kc_END:
					CmdArray.Cmd[6] = TRUE;
					CmdArray.Cmd[8] = TRUE;
					break;

				case kc_SPACE:
					CmdArray.Cmd[7] = TRUE;

					if(gKeyArray.Key[kc_END]) {
						CmdArray.Cmd[6] = TRUE;
						CmdArray.Cmd[8] = FALSE;
					} else {
						CmdArray.Cmd[8] = TRUE;
					}
					break;
			}
		}
	}

	gCmdArray = CmdArray;
	
	m_Indicator.SetKeyArray(&gKeyArray);
	CDialog::OnTimer(nIDEvent);
}
